* configure: Check for bison before byacc.
[deliverable/binutils-gdb.git] / configure.in
CommitLineData
9bdd52dd 1##############################################################################
eb02fd64 2
041164e4
DZ
3## This file is a shell script fragment that supplies the information
4## necessary to tailor a template configure script into the configure
5## script appropriate for this directory. For more information, check
6## any existing configure script.
ba4513e7 7
041164e4
DZ
8## Be warned, there are two types of configure.in files. There are those
9## used by Autoconf, which are macros which are expanded into a configure
10## script by autoconf. The other sort, of which this is one, is executed
11## by Cygnus configure.
ba4513e7 12
041164e4
DZ
13## For more information on these two systems, check out the documentation
14## for 'Autoconf' (autoconf.texi) and 'Configure' (configure.texi).
ba4513e7 15
9bdd52dd 16##############################################################################
041164e4
DZ
17
18### To add a new directory to the tree, first choose whether it is a target
19### or a host dependent tool. Then put it into the appropriate list
20### (library or tools, host or target), doing a dependency sort. For
21### example, gdb requires that byacc (or bison) be built first, so it is in
22### the ${host_tools} list after byacc and bison.
23
24
25# these libraries are used by various programs built for the host environment
26#
6d3055cb 27host_libs="mmalloc libiberty opcodes bfd readline gash tcl tk tclX"
041164e4 28
f4a7dca7
TL
29if [ "${enable_gdbgui}" = "yes" ] ; then
30 host_libs="${host_libs} libgui"
31fi
32
041164e4
DZ
33# these tools are built for the host environment
34#
35host_tools="texinfo byacc flex bison binutils ld gas gcc gdb make patch
d6c8b354 36 prms send-pr gprof gdbtest tgas etc expect dejagnu sim
e718498b 37 m4 autoconf ispell grep diff rcs cvs fileutils shellutils
e37bb3c7 38 textutils wdiff find emacs emacs19 uudecode hello tar gzip indent
bb9ae458 39 recode release sed utils"
041164e4
DZ
40
41
9bdd52dd
DZ
42# these libraries are built for the target environment, and are built after
43# the host libraries and the host tools (which may be a cross compiler)
041164e4 44#
77cd090a 45target_libs="target-libiberty target-libgloss target-newlib target-libio target-librx target-libstdc++ target-libg++"
6218894f 46
041164e4 47
9bdd52dd 48# these tools are built using the target libs, and are intended to run only
9623e828 49# in the target environment
83a47678 50#
9bdd52dd
DZ
51# note: any program that *uses* libraries that are in the "target_libs"
52# list belongs in this list. those programs are also very likely
53# candidates for the "native_only" list which follows
041164e4 54#
b58d9e5d 55target_tools="target-examples target-groff"
041164e4
DZ
56
57################################################################################
58
59## These two lists are of directories that are to be removed from the
60## ${configdirs} list for either cross-compilations or for native-
61## compilations. For example, it doesn't make that much sense to
ab1cbc67 62## cross-compile Emacs, nor is it terribly useful to compile target-libiberty in
041164e4
DZ
63## a native environment.
64
65# directories to be built in the native environment only
66#
b58d9e5d 67native_only="autoconf cvs emacs emacs19 fileutils find grep gzip hello
86c3abaa 68 indent ispell m4 rcs recode sed shellutils tar textutils gash
b58d9e5d 69 uudecode wdiff gprof target-groff"
041164e4 70
9bdd52dd 71# directories to be built in a cross environment only
041164e4 72#
ab1cbc67 73cross_only="target-libiberty target-libgloss target-newlib"
041164e4
DZ
74
75## All tools belong in one of the four categories, and are assigned above
8f30a41e
DE
76## We assign ${configdirs} this way to remove all embedded newlines. This
77## is important because configure will choke if they ever get through.
ca2ce3b3
ILT
78## ${configdirs} is directories we build using the host tools.
79## ${target_configdirs} is directories we build using the target tools.
041164e4 80#
ca2ce3b3
ILT
81configdirs=`echo ${host_libs} ${host_tools}`
82target_configdirs=`echo ${target_libs} ${target_tools}`
041164e4
DZ
83
84################################################################################
ba4513e7 85
378fd382 86srctrigger=move-if-change
eb02fd64 87srcname="gnu development package"
0df06ca0 88
af9fa3c1
ILT
89# This gets set non-empty for some net releases of packages.
90appdirs=""
91
0df06ca0
RP
92# per-host:
93
594c548a
DM
94# Work in distributions that contain no compiler tools, like Autoconf.
95if [ -d ${srcdir}/config ]; then
cec673a2 96case "${host}" in
c71350fc 97 m68k-hp-hpux*) host_makefile_frag=config/mh-hp300 ;;
cec673a2
DZ
98 m68k-apollo-sysv*) host_makefile_frag=config/mh-apollo68 ;;
99 m68k-apollo-bsd*) host_makefile_frag=config/mh-a68bsd ;;
cec673a2 100 m88k-dg-dgux*) host_makefile_frag=config/mh-dgux ;;
48de3495
SS
101 m88k-harris-cxux*) host_makefile_frag=config/mh-cxux ;;
102 m88k-motorola-sysv*) host_makefile_frag=config/mh-delta88;;
e718498b 103 mips*-dec-ultrix*) host_makefile_frag=config/mh-decstation ;;
031eff55 104 mips*-sgi-irix[56]*) host_makefile_frag=config/mh-irix5 ;;
e718498b
DZ
105 mips*-sgi-irix4*) host_makefile_frag=config/mh-irix4 ;;
106 mips*-sgi-irix3*) host_makefile_frag=config/mh-sysv ;;
49ad26c2 107 mips*-*-sysv4*) host_makefile_frag=config/mh-sysv4 ;;
e718498b 108 mips*-*-sysv*) host_makefile_frag=config/mh-riscos ;;
7e290a5d 109 i[345]86-ncr-sysv4.3) host_makefile_frag=config/mh-ncrsvr43 ;;
a73fc881 110 i[345]86-ncr-sysv4*) host_makefile_frag=config/mh-ncr3000 ;;
a48876fc 111 i[345]86-*-sco3.2v5*) host_makefile_frag=config/mh-sysv ;;
a73fc881
ILT
112 i[345]86-*-sco*) host_makefile_frag=config/mh-sco ;;
113 i[345]86-*-isc*) host_makefile_frag=config/mh-sysv ;;
114 i[345]86-*-linux*) host_makefile_frag=config/mh-linux ;;
115 i[345]86-*-solaris2*) host_makefile_frag=config/mh-sysv4 ;;
116 i[345]86-*-aix*) host_makefile_frag=config/mh-aix386 ;;
117 i[345]86-*-go32*) host_makefile_frag=config/mh-go32 ;;
d3c06c91 118 vax-*-ultrix2*) host_makefile_frag=config/mh-vaxult2 ;;
54fdaa7b 119 *-*-solaris2*) host_makefile_frag=config/mh-solaris ;;
39772dd8 120 m68k-sun-sunos*) host_makefile_frag=config/mh-sun3 ;;
0259fc73 121 *-hp-hpux[78]*) host_makefile_frag=config/mh-hpux8 ;;
c71350fc 122 *-hp-hpux*) host_makefile_frag=config/mh-hpux ;;
9117f609 123 *-*-hiux*) host_makefile_frag=config/mh-hpux ;;
af9fa3c1 124 rs6000-*-lynxos*) host_makefile_frag=config/mh-lynxrs6k ;;
89c27486 125 *-*-lynxos*) host_makefile_frag=config/mh-lynxos ;;
fab5d4e3
DZ
126 *-*-sysv4*) host_makefile_frag=config/mh-sysv4 ;;
127 *-*-sysv*) host_makefile_frag=config/mh-sysv ;;
f4bda0ff 128esac
594c548a 129fi
f4bda0ff 130
0e47ce97
ILT
131# If we aren't going to be using gcc, see if we can extract a definition
132# of CC from the fragment.
133if [ -z "${CC}" -a "${build}" = "${host}" ]; then
134 IFS="${IFS= }"; save_ifs="$IFS"; IFS="${IFS}:"
135 found=
136 for dir in $PATH; do
137 test -z "$dir" && dir=.
138 if test -f $dir/gcc; then
139 found=yes
140 break
141 fi
142 done
143 IFS="$save_ifs"
144 if [ -z "${found}" -a -n "${host_makefile_frag}" -a -f "${srcdir}/${host_makefile_frag}" ]; then
2f9bfdfa
SG
145 xx=`sed -n -e 's/^[ ]*CC[ ]*=[ ]*\(.*\)$/\1/p' < ${srcdir}/${host_makefile_frag}`
146 if [ -n "${xx}" ] ; then
147 CC=$xx
148 fi
ca2ce3b3
ILT
149 fi
150fi
151
45329a2c
JM
152# We default to --with-shared on platforms where -fpic is meaningless.
153# Well, we don't yet, but we will.
154if false && [ "${host}" = "${target}" ] && [ x${enable_shared} = x ]; then
155 case "${target}" in
156 alpha-dec-osf*) enable_shared=yes ;;
157 mips-sgi-irix5*) enable_shared=yes ;;
158 *) enable_shared=no ;;
159 esac
160fi
161
162if [ x${enable_shared} = xyes ]; then
163 waugh=
164 case "${host}" in
c9e55665
JM
165 hppa*) waugh=config/mh-papic ;;
166 i[345]86-*) waugh=config/mh-x86pic ;;
167 *) waugh=config/mh-${host_cpu}pic ;;
45329a2c 168 esac
4350753e
JM
169 if [ -f ${srcdir}/${waugh} ]; then
170 if [ -n "${host_makefile_frag}" ] ; then
171 cat ${srcdir}/${host_makefile_frag} > mh-frag
172 cat ${srcdir}/${waugh} >> mh-frag
173 host_makefile_frag=mh-frag
c9e55665
JM
174 else
175 host_makefile_frag=${waugh}
4350753e 176 fi
45329a2c
JM
177 fi
178fi
179
0df06ca0 180# per-target:
bc58b41d 181
9ab10a5b
SEF
182case "${target}" in
183 v810*) target_makefile_frag=config/mt-v810 ;;
138e8532
JM
184 i[345]86-*-netware*) target_makefile_frag=config/mt-netware ;;
185 powerpc-*-netware*) target_makefile_frag=config/mt-netware ;;
9ab10a5b
SEF
186esac
187
ca2ce3b3 188skipdirs=
719cb03f
DZ
189gasdir=gas
190use_gnu_ld=
191use_gnu_as=
192
9f579565
DZ
193# some tools are so dependent upon X11 that if we're not building with X,
194# it's not even worth trying to configure, much less build, that tool.
195
196case ${with_x} in
e13fa011 197 yes | "") # the default value for this tree is that X11 is available
6a42d184 198 ;;
e13fa011 199 no)
ca2ce3b3 200 skipdirs="${skipdirs} tk gash"
9f579565
DZ
201 ;;
202 *)
203 echo "*** bad value \"${with_x}\" for -with-x flag; ignored" 1>&2
204 ;;
205esac
206
5357f128 207# Some tools are only suitable for building in a "native" situation.
ba4513e7
DZ
208# Those are added when we have a host==target configuration. For cross
209# toolchains, we add some directories that should only be useful in a
210# cross-compiler.
43557c0a 211
2a38983c
DHW
212is_cross_compiler=
213
94028943 214if [ x"${host}" = x"${target}" ] ; then
041164e4
DZ
215 # when doing a native toolchain, don't build the targets
216 # that are in the 'cross only' list
ca2ce3b3 217 skipdirs="${skipdirs} ${cross_only}"
2a38983c 218 is_cross_compiler=no
ab1cbc67 219 target_subdir=.
43557c0a 220else
041164e4
DZ
221 # similarly, don't build the targets in the 'native only'
222 # list when building a cross compiler
ca2ce3b3 223 skipdirs="${skipdirs} ${native_only}"
2a38983c 224 is_cross_compiler=yes
ab1cbc67
PB
225 target_subdir=${target_alias}
226 if [ ! -d ${target_subdir} ] ; then
227 if mkdir ${target_subdir} ; then true
228 else
229 echo "'*** could not make ${PWD=`pwd`}/${target_subdir}" 1>&2
230 exit 1
231 fi
232 fi
43557c0a
DZ
233fi
234
055cca84
ILT
235copy_dirs=
236
237# Handle --with-headers=XXX. The contents of the named directory are
52b5deb9 238# copied to $(tooldir)/sys-include.
055cca84
ILT
239if [ x"${with_headers}" != x ]; then
240 if [ x${is_cross_compiler} = xno ]; then
241 echo 1>&2 '***' --with-headers is only supported when cross compiling
242 exit 1
243 fi
244 case "${exec_prefixoption}" in
245 "") x=${prefix} ;;
246 *) x=${exec_prefix} ;;
247 esac
52b5deb9 248 copy_dirs="${copy_dirs} ${with_headers} $x/${target_alias}/sys-include"
055cca84
ILT
249fi
250
251# Handle --with-libs=XXX. Multiple directories are permitted. The
252# contents are copied to $(tooldir)/lib.
253if [ x"${with_libs}" != x ]; then
254 if [ x${is_cross_compiler} = xno ]; then
255 echo 1>&2 '***' --with-libs is only supported when cross compiling
256 exit 1
257 fi
258 # Copy the libraries in reverse order, so that files in the first named
259 # library override files in subsequent libraries.
260 case "${exec_prefixoption}" in
261 "") x=${prefix} ;;
262 *) x=${exec_prefix} ;;
263 esac
264 for l in ${with_libs}; do
265 copy_dirs="$l $x/${target_alias}/lib ${copy_dirs}"
266 done
267fi
268
269# If both --with-headers and --with-libs are specified, default to
270# --without-newlib.
271if [ x"${with_headers}" != x ] && [ x"${with_libs}" != x ]; then
272 if [ x"${with_newlib}" = x ]; then
273 with_newlib=no
274 fi
275fi
276
99dff294 277# Recognize --with-newlib/--without-newlib.
055cca84 278if [ x${with_newlib} = xno ]; then
ab1cbc67 279 skipdirs="${skipdirs} target-newlib"
99dff294 280elif [ x${with_newlib} = xyes ]; then
ab1cbc67 281 skipdirs=`echo " ${skipdirs} " | sed -e 's/ target-newlib / /'`
055cca84
ILT
282fi
283
4f0ad91b
ILT
284# Default to using --with-stabs for certain targets.
285if [ x${with_stabs} = x ]; then
286 case "${target}" in
287 mips*-*-* | alpha*-*-osf* | i[345]86*-*-sysv4* | i[345]86*-*-unixware*)
288 with_stabs=yes;
289 withoptions="${withoptions} --with-stabs"
290 ;;
291 esac
292fi
293
055cca84
ILT
294# Handle ${copy_dirs}
295set fnord ${copy_dirs}
296shift
297while [ $# != 0 ]; do
298 if [ -f $2/COPIED ] && [ x"`cat $2/COPIED`" = x"$1" ]; then
299 :
300 else
301 echo Copying $1 to $2
302
303 # Use the install script to create the directory and all required
304 # parent directories.
305 if [ -d $2 ]; then
306 :
307 else
308 echo >config.temp
309 ${srcdir}/install.sh -c -m 644 config.temp $2/COPIED
310 fi
311
312 # Copy the directory, assuming we have tar.
313 # FIXME: Should we use B in the second tar? Not all systems support it.
314 (cd $1; tar -cf - .) | (cd $2; tar -xpf -)
315
316 # It is the responsibility of the user to correctly adjust all
317 # symlinks. If somebody can figure out how to handle them correctly
318 # here, feel free to add the code.
319
320 echo $1 > $2/COPIED
321 fi
322 shift; shift
323done
324
eebd76cb
SC
325# Configure extra directories which are host specific
326
327case "${host}" in
9daacfc4 328 i[345]86-*-go32*)
a220ba0f 329 configdirs="$configdirs dosrel" ;;
eebd76cb
SC
330esac
331
5357f128 332# Remove more programs from consideration, based on the host or
dfa891fc 333# target this usually means that a port of the program doesn't
8ae559b7 334# exist yet.
dfa891fc 335
52e3ad87
KR
336noconfigdirs=""
337
9f579565 338case "${host}" in
a73fc881 339 i[345]86-*-vsta)
8a3871bb
RS
340 noconfigdirs="tcl expect dejagnu make texinfo bison patch flex byacc send-pr gprof uudecode dejagnu diff"
341 ;;
a73fc881 342 i[345]86-*-go32)
795f1885 343 noconfigdirs="tcl tk expect dejagnu make texinfo bison patch flex byacc send-pr gprof uudecode dejagnu diff"
8c7fd353 344 ;;
9daacfc4
SC
345 *-*-cygwin32)
346 noconfigdirs="patch diff make tk tcl expect dejagnu cvs autoconf texinfo bison send-pr gprof rcs"
9f579565 347 ;;
a51794f1 348 ppc*-*-pe)
9daacfc4 349 noconfigdirs="patch diff make tk tcl expect dejagnu cvs autoconf texinfo bison send-pr gprof rcs"
a51794f1 350 ;;
9f579565 351esac
dfa891fc 352
eebd76cb 353
43557c0a 354case "${target}" in
0f45fbc1 355 *-*-netware)
ab1cbc67 356 noconfigdirs="$noconfigdirs target-libg++ target-libstdc++ target-librx target-newlib target-libiberty"
0f45fbc1 357 ;;
406477a6 358 *-*-vxworks*)
ab1cbc67 359 noconfigdirs="$noconfigdirs target-newlib"
849367a2 360 ;;
6bd3f765
ILT
361 alpha-dec-osf*)
362 # ld works, but does not support shared libraries. emacs doesn't
f4791d95 363 # work. newlib is not 64 bit ready. I'm not sure about fileutils or grep.
2a3486d2
ILT
364 # gas doesn't generate exception information.
365 noconfigdirs="$noconfigdirs gas ld emacs fileutils grep target-newlib"
0f45fbc1 366 ;;
04b9315f 367 alpha*-*-*)
6bd3f765 368 # newlib is not 64 bit ready
ab1cbc67 369 noconfigdirs="$noconfigdirs target-newlib"
0f45fbc1 370 ;;
7c71fc39
DE
371# start-sanitize-arc
372 arc-*-*)
7c71fc39
DE
373 ;;
374# end-sanitize-arc
bf150019 375 arm-*-pe*)
bf150019 376 ;;
ff15324f 377 arm-*-riscix*)
318b02b6
KR
378 noconfigdirs="$noconfigdirs ld"
379 ;;
52e3ad87 380 h8300*-*-* | \
8388b9df 381 h8500-*-*)
ab1cbc67 382 noconfigdirs="$noconfigdirs target-libg++ target-libstdc++ target-libio target-librx"
15ae586e 383 ;;
8a71f0f3 384 hppa*-*-*elf* | \
55ac59da 385 hppa*-*-lites*)
8c92a7d1 386 # Do configure ld/binutils/gas for this case.
99a5da15 387 ;;
15ae586e 388 hppa*-*-*)
408f64bc
JK
389 # HP's C compiler doesn't handle Emacs correctly (but on BSD and Mach
390 # cc is gcc, and on any system a user should be able to link cc to
e37bb3c7 391 # whatever they want. FIXME, emacs emacs19).
8b5405d2 392 case "${CC}" in
e37bb3c7 393 "" | cc*) noconfigdirs="$noconfigdirs emacs emacs19" ;;
772ebace 394 *) ;;
8b5405d2 395 esac
d9f1d487 396 noconfigdirs="$noconfigdirs ld shellutils"
15ae586e 397 ;;
a73fc881 398 i[345]86-*-go32)
632ee4a1 399 # but don't build gdb
ab1cbc67 400 noconfigdirs="$noconfigdirs gdb target-libg++ target-libstdc++ target-libio target-librx"
8c92a7d1 401 ;;
9daacfc4
SC
402 *-*-cygwin32)
403
600b2f21 404 # make/glob's configure uses some AC_TRY_RUN type tests
77cd090a 405 target_configdirs="$target_configdirs target-winsup"
9daacfc4 406 noconfigdirs="$noconfigdirs tcl tk expect make"
e1a1ddc6 407 # always build newlib.
ab1cbc67 408 skipdirs=`echo " ${skipdirs} " | sed -e 's/ target-newlib / /'`
9daacfc4
SC
409
410 # Can't build gdb for cygwin32 if not native.
44ccfc3c
MM
411 case "${host}:${build}" in
412 *-*-cygwin32 | *-*-cygwin32:*-*-cygwin32) ;; # keep gdb
9daacfc4
SC
413 *) noconfigdirs="$noconfigdirs gdb"
414 esac
415
a220ba0f 416 ;;
8c7fd353 417 i[345]86-*-pe)
ab1cbc67 418 noconfigdirs="$noconfigdirs target-libg++ target-libstdc++ target-libio target-librx"
8c7fd353 419 ;;
a48876fc
SS
420 i[345]86-*-sco3.2v5*)
421 # The linker does not yet know about weak symbols in COFF,
422 # and is not configured to handle mixed ELF and COFF.
423 noconfigdirs="$noconfigdirs gprof ld"
424 ;;
a73fc881 425 i[345]86-*-sco*)
de9117a7
KR
426 noconfigdirs="$noconfigdirs gprof"
427 ;;
a73fc881 428 i[345]86-*-solaris2*)
320c9fff
KR
429 # The linker does static linking correctly, but the Solaris C library
430 # has bugs such that some important functions won't work when statically
431 # linked. (See man pages for getpwuid, for example.)
432 noconfigdirs="$noconfigdirs ld"
433 ;;
a73fc881 434 i[345]86-*-sysv4*)
8b5405d2
DZ
435 # The SYSV4 C compiler doesn't handle Emacs correctly
436 case "${CC}" in
e37bb3c7 437 "" | cc*) noconfigdirs="$noconfigdirs emacs emacs19" ;;
8b5405d2
DZ
438 *) ;;
439 esac
440 # but that's okay since emacs doesn't work anyway
e37bb3c7 441 noconfigdirs="$noconfigdirs emacs emacs19"
8b5405d2 442 ;;
3e1e245d
ILT
443 powerpc-*-aix*)
444 # copied from rs6000-*-* entry
92caaa6a 445 noconfigdirs="$noconfigdirs gprof cvs"
3e1e245d 446 ;;
a51794f1
JM
447 powerpc*-*-winnt* | powerpc*-*-pe* | ppc*-*-pe)
448 target_configdirs="$target_configdirs target-winsup"
449 noconfigdirs="$noconfigdirs gdb tcl tk make expect"
450 # always build newlib.
451 skipdirs=`echo " ${skipdirs} " | sed -e 's/ target-newlib / /'`
81d08d0c 452 ;;
2a38983c 453 rs6000-*-lynxos*)
2a38983c
DHW
454 # The CVS server code doesn't work on the RS/6000
455 # Newlib makes problems for libg++ in crosses.
92caaa6a 456 noconfigdirs="$noconfigdirs target-newlib gprof cvs"
2a38983c 457 ;;
8388b9df 458 rs6000-*-*)
92caaa6a 459 noconfigdirs="$noconfigdirs gprof"
fcf4d286 460 ;;
d55a8267
C
461 m68k-*-netbsd*)
462 noconfigdirs="$noconfigdirs gdb"
463 ;;
becf2d8a
JK
464 m68k-apollo-*)
465 noconfigdirs="$noconfigdirs ld binutils gprof"
466 ;;
04b9315f
ILT
467 mips*-*-irix5*)
468 # The GNU linker does not support shared libraries.
82633710
ILT
469 # emacs is emacs 18, which does not work on Irix 5 (emacs19 does work)
470 noconfigdirs="$noconfigdirs ld gprof emacs"
04b9315f 471 ;;
af9fa3c1
ILT
472 mips*-dec-bsd*)
473 noconfigdirs="$noconfigdirs gprof"
474 ;;
475 mips*-*-bsd*)
ffb8885b 476 noconfigdirs="$noconfigdirs gprof"
af9fa3c1 477 ;;
04b9315f 478 mips*-*-*)
52e3ad87 479 noconfigdirs="$noconfigdirs gprof"
fcf4d286 480 ;;
de9117a7 481 romp-*-*)
ca2ce3b3 482 noconfigdirs="$noconfigdirs bfd binutils ld gas opcodes"
de9117a7 483 ;;
817382d1 484 sh-*-*)
719cb03f 485 case "${host}" in
a73fc881 486 i[345]86-*-vsta) ;; # don't add gprof back in
a73fc881 487 i[345]86-*-go32) ;; # don't add gprof back in
ca2ce3b3 488 *) skipdirs=`echo " ${skipdirs} " | sed -e 's/ gprof / /'` ;;
719cb03f
DZ
489 esac
490 ;;
491 sparc-*-sunos4*)
2a38983c 492 if [ x${is_cross_compiler} != xno ] ; then
ab1cbc67 493 noconfigdirs="$noconfigdirs gdb gdbtest target-newlib"
2a38983c
DHW
494 else
495 use_gnu_ld=no
496 fi
1f69e88d 497 ;;
e08dfe61
DE
498 sparclet-*-*)
499 # Skip these until ready for them.
500 noconfigdirs="$noconfigdirs target-libg++ target-libstdc++ target-libio target-librx"
e61b005e 501 ;;
486e0f0a 502 v810-*-*)
d25fd70d 503 noconfigdirs="$noconfigdirs bfd binutils gas gcc gdb ld target-libio target-libg++ target-libstdc++ opcodes"
486e0f0a 504 ;;
de9117a7 505 vax-*-vms)
ab1cbc67 506 noconfigdirs="$noconfigdirs bfd binutils gdb ld target-newlib opcodes"
de9117a7
KR
507 ;;
508 vax-*-*)
ab1cbc67 509 noconfigdirs="$noconfigdirs target-newlib"
8388b9df 510 ;;
de9117a7 511 *-*-lynxos*)
19b1d034
SS
512 # Newlib makes problems for libg++ in crosses.
513 noconfigdirs="$noconfigdirs target-newlib"
514 ;;
515 *-*-macos* | \
516 *-*-mpw*)
517 # Macs want a resource compiler.
518 configdirs="$configdirs grez"
519 ;;
05cd8d98
HS
520esac
521
fcfcbf27 522# targets that need a second pass
0807a8af
GN
523case "${target}" in
524 *-gm-magic*)
525 noconfigdirs="$noconfigdirs libgloss"
526 ;;
527esac
528
bfe725ec
ILT
529# If we are building a Canadian Cross, discard tools that can not be built
530# using a cross compiler. FIXME: These tools should be fixed.
531if [ "${build}" != "${host}" ]; then
532 noconfigdirs="$noconfigdirs expect dejagnu make texinfo diff"
533fi
534
d4cf72b3
BK
535# Make sure we don't let GNU ld be added if we didn't want it.
536if [ x$with_gnu_ld = xno ]; then
537 use_gnu_ld=no
538 noconfigdirs="$noconfigdirs ld"
0b0124c6
BK
539fi
540
d4cf72b3
BK
541# Make sure we don't let GNU as be added if we didn't want it.
542if [ x$with_gnu_as = xno ]; then
543 use_gnu_as=no
544 noconfigdirs="$noconfigdirs gas"
0b0124c6
BK
545fi
546
ca2ce3b3
ILT
547# Remove the entries in $skipdirs and $noconfigdirs from $configdirs and
548# $target_configdirs.
549# If we have the source for $noconfigdirs entries, add them to $notsupp.
efd7b806 550
52e3ad87 551notsupp=""
ca2ce3b3 552for dir in . $skipdirs $noconfigdirs ; do
b58d9e5d 553 dirname=`echo $dir | sed -e s/target-//g`
1c15a33d 554 if [ $dir != . ] && echo " ${configdirs} " | grep " ${dir} " >/dev/null 2>&1; then
8f30a41e 555 configdirs=`echo " ${configdirs} " | sed -e "s/ ${dir} / /"`
b58d9e5d
PB
556 if [ -r $srcdir/$dirname/configure ] \
557 || [ -r $srcdir/$dirname/configure.in ]; then
ca2ce3b3
ILT
558 if echo " ${skipdirs} " | grep " ${dir} " >/dev/null 2>&1; then
559 true
560 else
561 notsupp="$notsupp $dir"
562 fi
563 fi
564 fi
565 if [ $dir != . ] && echo " ${target_configdirs} " | grep " ${dir} " >/dev/null 2>&1; then
566 target_configdirs=`echo " ${target_configdirs} " | sed -e "s/ ${dir} / /"`
b58d9e5d
PB
567 if [ -r $srcdir/$dirname/configure ] \
568 || [ -r $srcdir/$dirname/configure.in ]; then
ca2ce3b3
ILT
569 if echo " ${skipdirs} " | grep " ${dir} " >/dev/null 2>&1; then
570 true
571 else
572 notsupp="$notsupp $dir"
573 fi
52e3ad87
KR
574 fi
575 fi
576done
577
fba66802
ILT
578# Sometimes the tools are distributed with libiberty but with no other
579# libraries. In that case, we don't want to build target-libiberty.
580if [ -n "${target_configdirs}" ]; then
581 others=
b58d9e5d 582 for i in `echo ${target_configdirs} | sed -e s/target-//g` ; do
fba66802
ILT
583 if [ "$i" != "libiberty" ]; then
584 if [ -r $srcdir/$i/configure ] || [ -r $srcdir/$i/configure.in ]; then
585 others=yes;
586 break;
587 fi
588 fi
589 done
590 if [ -z "${others}" ]; then
591 target_configdirs=
592 fi
593fi
594
ca2ce3b3
ILT
595# Deconfigure all subdirectories, in case we are changing the
596# configuration from one where a subdirectory is supported to one where it
597# is not.
ab1cbc67 598if [ -z "${norecursion}" -a -n "${configdirs}" ]; then
b58d9e5d 599 for i in `echo ${configdirs} | sed -e s/target-//g` ; do
ca2ce3b3
ILT
600 rm -f $i/Makefile
601 done
602fi
ab1cbc67 603if [ -z "${norecursion}" -a -n "${target_configdirs}" ]; then
b58d9e5d 604 for i in `echo ${target_configdirs} | sed -e s/target-//` ; do
ab1cbc67
PB
605 rm -f ${target_subdir}/$i/Makefile
606 done
607fi
ca2ce3b3 608
52e3ad87
KR
609# Produce a warning message for the subdirs we can't configure.
610# This isn't especially interesting in the Cygnus tree, but in the individual
611# FSF releases, it's important to let people know when their machine isn't
612# supported by the one or two programs in a package.
613
9fe444b5 614if [ -n "${notsupp}" ] && [ -z "${norecursion}" ]; then
af9fa3c1
ILT
615 # If $appdirs is non-empty, at least one of those directories must still
616 # be configured, or we error out. (E.g., if the gas release supports a
617 # specified target in some subdirs but not the gas subdir, we shouldn't
618 # pretend that all is well.)
619 if [ -n "$appdirs" ]; then
620 for dir in $appdirs ; do
ca2ce3b3
ILT
621 if [ -r $dir/Makefile.in ]; then
622 if echo " ${configdirs} " | grep " ${dir} " >/dev/null 2>&1; then
623 appdirs=""
624 break
625 fi
626 if echo " ${target_configdirs} " | grep " ${dir} " >/dev/null 2>&1; then
627 appdirs=""
628 break
629 fi
af9fa3c1
ILT
630 fi
631 done
632 if [ -n "$appdirs" ]; then
633 echo "*** This configuration is not supported by this package." 1>&2
634 exit 1
635 fi
636 fi
637 # Okay, some application will build, or we don't care to check. Still
638 # notify of subdirs not getting built.
52e3ad87
KR
639 echo "*** This configuration is not supported in the following subdirectories:" 1>&2
640 echo " ${notsupp}" 1>&2
641 echo " (Any other directories should still work fine.)" 1>&2
642fi
643
d4cf72b3
BK
644# Set with_gnu_as and with_gnu_ld as appropriate.
645#
646# This is done by determining whether or not the appropriate directory
647# is available, and by checking whether or not specific configurations
648# have requested that this magic not happen.
649#
650# The command line options always override the explicit settings in
651# configure.in, and the settings in configure.in override this magic.
652#
653# If the default for a toolchain is to use GNU as and ld, and you don't
654# want to do that, then you should use the --without-gnu-as and
655# --without-gnu-ld options for the configure script.
656
657if [ x${use_gnu_as} = x ] ; then
658 if [ x${with_gnu_as} != xno ] && echo " ${configdirs} " | grep " ${gasdir} " > /dev/null 2>&1 && [ -d ${srcdir}/${gasdir} ] ; then
659 with_gnu_as=yes
660 withoptions="$withoptions --with-gnu-as"
661 fi
662fi
663
664if [ x${use_gnu_ld} = x ] ; then
665 if [ x${with_gnu_ld} != xno ] && echo " ${configdirs} " | grep " ld " > /dev/null 2>&1 && [ -d ${srcdir}/ld ] ; then
666 with_gnu_ld=yes
667 withoptions="$withoptions --with-gnu-ld"
668 fi
669fi
670
45329a2c
JM
671if [ x${enable_shared} = xyes ]; then
672 case "${target}" in
c9e55665
JM
673 hppa*) target_makefile_frag=config/mt-papic ;;
674 i[345]86-*) target_makefile_frag=config/mt-x86pic ;;
675 *) target_makefile_frag=config/mt-${target_cpu}pic ;;
45329a2c
JM
676 esac
677fi
678
ca2ce3b3
ILT
679# post-target:
680
b5ae8419
ILT
681# Make sure that the compiler is able to generate an executable. If it
682# can't, we are probably in trouble. We don't care whether we can run the
683# executable--we might be using a cross compiler--we only care whether it
684# can be created. At this point the main configure script has set CC.
685echo "int main () { return 0; }" > conftest.c
686${CC} -o conftest ${CFLAGS} ${CPPFLAGS} ${LDFLAGS} conftest.c
687if [ $? = 0 ] && [ -s conftest ]; then
688 :
689else
690 echo 1>&2 "*** The command '${CC} -o conftest ${CFLAGS} ${CPPFLAGS} ${LDFLAGS} conftest.c' failed."
691 echo 1>&2 "*** You must set the environment variable CC to a working compiler."
692 rm -f conftest*
693 exit 1
694fi
695rm -f conftest*
696
0e47ce97
ILT
697# The Solaris /usr/ucb/cc compiler does not appear to work.
698case "${host}" in
699 sparc-sun-solaris2*)
700 if [ "`/usr/bin/which ${CC-cc}`" = "/usr/ucb/cc" ] ; then
701 could_use=
702 [ -d /opt/SUNWspro/bin ] && could_use="/opt/SUNWspro/bin"
703 if [ -d /opt/cygnus/bin ] ; then
704 if [ "$could_use" = "" ] ; then
705 could_use="/opt/cygnus/bin"
706 else
707 could_use="$could_use or /opt/cygnus/bin"
708 fi
709 fi
710 if [ "$could_use" = "" ] ; then
711 echo "Warning: compilation may fail because you're using"
712 echo "/usr/ucb/cc. You should change your PATH or CC "
713 echo "variable and rerun configure."
714 else
715 echo "Warning: compilation may fail because you're using"
716 echo "/usr/ucb/cc, when you should use the C compiler from"
717 echo "$could_use. You should change your"
718 echo "PATH or CC variable and rerun configure."
719 fi
720 fi
721 ;;
722esac
723
294fde1f
ILT
724# If --enable-shared was set, we must set LD_LIBRARY_PATH so that the
725# binutils tools will find libbfd.so.
726if [ "${enable_shared}" = "yes" ]; then
727 sed -e 's/^SET_LIB_PATH[ ]*=.*$/SET_LIB_PATH = $(REALLY_SET_LIB_PATH)/' \
728 Makefile > Makefile.tem
729 rm -f Makefile
730 mv -f Makefile.tem Makefile
f2693093
ILT
731
732 case "${host}" in
733 *-*-hpux*)
734 sed -e 's/RPATH_ENVVAR[ ]*=.*$/RPATH_ENVVAR = SHLIB_PATH/' \
735 Makefile > Makefile.tem
736 rm -f Makefile
737 mv -f Makefile.tem Makefile
738 ;;
739 esac
294fde1f
ILT
740fi
741
ca2ce3b3 742# Record target_configdirs and the configure arguments in Makefile.
ab1cbc67 743target_configdirs=`echo "${target_configdirs}" | sed -e 's/target-//g'`
ca2ce3b3 744targargs=`echo "${arguments}" | \
7fc36fda
ILT
745 sed -e 's/--norecursion//' \
746 -e 's/--cache[a-z-]*=[^ ]*//' \
747 -e 's/--ho[a-z-]*=[^ ]*//' \
748 -e 's/--ta[a-z-]*=[^ ]*//'`
749
750# Passing a --with-cross-host argument lets the target libraries know
751# whether they are being built with a cross-compiler or being built
752# native. However, it would be better to use other mechanisms to make the
753# sorts of decisions they want to make on this basis. Please consider
754# this option to be deprecated. FIXME.
755if [ x${is_cross_compiler} = xyes ]; then
90bdf864 756 targargs="--with-cross-host=${host_alias} ${targargs}"
7fc36fda
ILT
757fi
758
759targargs="--host=${target_alias} ${targargs}"
ca2ce3b3
ILT
760sed -e "s:^TARGET_CONFIGDIRS[ ]*=.*$:TARGET_CONFIGDIRS = ${target_configdirs}:" \
761 -e "s%^CONFIG_ARGUMENTS[ ]*=.*$%CONFIG_ARGUMENTS = ${targargs}%" \
ab1cbc67 762 -e "s%^TARGET_SUBDIR[ ]*=.*$%TARGET_SUBDIR = ${target_subdir}%" \
ca2ce3b3
ILT
763 Makefile > Makefile.tem
764rm -f Makefile
765mv -f Makefile.tem Makefile
766
bc58b41d
RP
767#
768# Local Variables:
769# fill-column: 131
770# End:
771#
This page took 0.19732 seconds and 4 git commands to generate.